package org.boxed_economy.ipd.model.behavior;

import org.boxed_economy.besp.model.fmfw.behavior.AbstractBehavior;

import org.boxed_economy.besp.model.fmfw.TimeEvent;
import org.boxed_economy.besp.model.fmfw.behavior.Action;
import org.boxed_economy.besp.model.fmfw.behavior.CompositeState;
import org.boxed_economy.besp.model.fmfw.behavior.State;
import org.boxed_economy.besp.model.fmfw.behavior.StateMachineFactory;
import org.boxed_economy.besp.model.fmfw.behavior.TemplateAction;
import org.boxed_economy.besp.model.fmfw.behavior.Transition;
import org.boxed_economy.ipd.model.behavior.template.ChangeStrategyAction;

/**
* AbstractChangeStrategyWithStrongerPlayersBehavior
*/
public abstract class AbstractChangeStrategyWithStrongerPlayersBehavior
	extends AbstractBehavior {

	/**
	* This method automatically generated from Boxed Economy Behavior Editor.
	* Don't modify this method.
	*/
	protected void initializeStateMachine() {
		//factory
		StateMachineFactory factory = this.getStateMachine();

		//states
		State initialState = factory.createInitialState();
		CompositeState waitingForTime =
			factory.createCompositeState("WaitingForTime");

		//actions
		TemplateAction changeStrategyAction = new ChangeStrategyAction();
		changeStrategyAction.setBehavior(this);
		Action memoryStrongerPlayersAction = new Action() {
			public void doAction() {
				memoryStrongerPlayersAction();
			}
			public String toString() {
				return "memoryStrongerPlayersAction";
			}
		};

		//guard-conditions

		//transitions
		Transition transitionWaitingForTimeToWaitingForTime =
			factory.createTransition();
		Transition transitionInitialStateToWaitingForTime =
			factory.createTransition();

		//states setting

		//structure of states
		this.setInitialState(initialState);
		this.addState(waitingForTime);

		//transitions setting
		transitionWaitingForTimeToWaitingForTime.setEvent(TimeEvent.class);
		transitionWaitingForTimeToWaitingForTime.addAction(
			memoryStrongerPlayersAction);
		transitionWaitingForTimeToWaitingForTime.addAction(
			changeStrategyAction);

		//connection of transitions
		transitionWaitingForTimeToWaitingForTime.setSourceState(waitingForTime);
		transitionWaitingForTimeToWaitingForTime.setTargetState(waitingForTime);
		transitionInitialStateToWaitingForTime.setSourceState(initialState);
		transitionInitialStateToWaitingForTime.setTargetState(waitingForTime);

	}

	/**
	*memoryStrongerPlayersAction
	*/
	protected abstract void memoryStrongerPlayersAction();
}
